#include <stdio.h>
#include "tame.h"

static tamed
back(int n, Rendezvous *go, event<int> *sig)
{
	tvars {}
	// Pause so the test case isn't trivial
	twait(go);
	printf("signal: %d\n", n);
	trigger(sig, n);
}

static tamed
forth(int n)
{
	tvars {
		Rendezvous *rv;
		event<> **go;
		int *val;
	}
	int i;

	printf("start!\n");
	val = emalloc(n * sizeof val[0]);
	rv  = emalloc(n * sizeof rv[0]);
	go  = emalloc(n * sizeof go[0]);

	twait {
		for(i=0; i < n; i++){
			go[i] = mkevent(&rv[i], -1);
			back(i*10, &rv[i], mkevent(i, &val[i]));
		}
		for(i=0; i < n; i++)
			trigger(go[i]);
		printf("waiting...\n");
	}

	for(i=0; i < n; i++)
		printf("response: %d = %d\n", i, val[i]);

	printf("done!\n");
}

int
main()
{
	tame_init();
	forth(10);
	tame_loop();
	return 0;
}

