#include "u.h"
#include "utf.h"
#include "fmt.h"
#include "errstr.h"
#include "error.h"

Error estack[100];
Error *estackp = estack;

void
kaboom(char *fmt, ...)
{
	char buf[256];
	va_list arg;
	
	if((char*)estackp >= (char*)estack+sizeof estack){
		fprint(2, "error stack overflow\n");
		abort();
	}
	va_start(arg, fmt);
	vsnprint(buf, sizeof buf, fmt, arg);
	va_end(arg);
	errstr(buf, sizeof buf);
	nexterror();
}

void
nexterror(void)
{
	if(estackp <= estack){
		fprint(2, "error stack underflow\n");
		abort();
	}
	estackp--;
	longjmp(estackp->jb, 1);
}

void
poperror(void)
{
	if(estackp <= estack){
		fprint(2, "error stack underflow\n");
		abort();
	}
	estackp--;
}

