#include "u.h"
#include "gflags.h"
#include "panic.h"
#include "utf.h"
#include "fmt.h"

DEFINE_bool(abort, true, "Abort on panic.");

void
panic(char *fmt, ...)
{
	va_list arg;

	fprint(2, "panic: ");
	va_start(arg, fmt);
	vfprint(2, fmt, arg);
	va_end(arg);
	fprint(2, "\n");
	if(FLAGS_abort)
		abort();
	exit(0);
}

