extern int printf(char*, ...);

int failed;
int counter, counter2;

void
assertint(int want, int got)
{
	if(want != got) {
		printf("FAILURE: Expected %d, got %d\n", want, got);
		failed = 1;
	}
}

int
dec(void)
{
	return counter--;
}

int
dec2(void)
{
	return counter2--;
}

int
main(int argc, char **argv)
{
	int expect, expect2, total;

	// Basic while test
	counter = expect = 5;
	while(dec()) {
		assertint(it, expect);
		expect--;
	}
	assertint(-1, counter);

	// Basic if test
	if(42)
		assertint(42, it);
	else {
		printf("FAILED: 42 not taken\n");
		failed = 1;
	}

	// If scoping test
	expect = 42;
	if(expect)
		assertint(42, it);
	else {
		printf("FAILED: expected not taken\n");
		failed = 1;
	}

	// Test nested anaphoric while's
	counter = expect = 3;
	total = 0;
	while(dec()) {
		assertint(it, expect);
		expect--;
		counter2 = expect2 = 3;
		while(dec2()) {
			assertint(it, expect2);
			expect2--;
			total++;
		}
		assertint(-1, counter2);
	}
	assertint(-1, counter);
	assertint(9, total);

	// Nested if's
	if(42) {
		if(it == 42) {
			assertint(1, it);
		} else {
			printf("FAILED: it == 42 not taken\n");
			failed = 1;
		}
		assertint(42, it);
	}

	if(!failed) {
		printf("PASSED\n");
		return 0;
	}
	return 1;
}
