extern int printf(char*, ...);

int failed;

void
assertint(int want, int got)
{
	if(want != got) {
		printf("FAILURE: Expected %d, got %d\n", want, got);
		failed = 1;
	}
}

int
main(int argc, char **argv)
{
	int a, b;

	a = 1, b = 2;
	assertint(1, a <? b);
	assertint(1, b <? a);
	assertint(2, a >? b);
	assertint(2, b >? a);

	assertint(1, a++ <? b++);
	assertint(2, a);
	assertint(3, b);

	a = 1, b = 2;
	a <?= b;
	assertint(1, a);
	assertint(2, b);
	a >?= b;
	assertint(2, a);
	assertint(2, b);

	if(!failed)
		printf("PASSED\n");
	return 0;
}
