#include "lambda.h"
extern int printf(char*, ...);
extern void qsort(void *base, int nmemb, int size,
		  int(*compar)(const void *, const void *));

extern int strcasecmp(const char *s1, const char *s2);
extern int strcmp(const char *s1, const char *s2);

int
main(int argc, char **argv)
{
	int caseinsensitive = 0;
	if (strcmp(argv[1], "-i") == 0)
		caseinsensitive = 1, ++argv, --argc;
	qsort(&argv[1], argc-1, sizeof(char*),
	      fn int compare(const void *a, const void *b) {
		      if (caseinsensitive)
			      return strcasecmp(*(char**)a, *(char**)b);
		      return strcmp(*(char**)a, *(char**)b);
	      });
	// Omit the below, probably
	int i;
	for(i = 1; i < argc; ++i)
		printf("%s\n", argv[i]);
	return 0;
}
