struct TypeRefinement;

struct Typecheck
{
	Typecheck(Frame *frame, Scope *scope) :
		reachable_(0),
		frame_(frame),
		scope_(scope),
		fn_(nil),
		pcs_(nil),
		typerefines_(nil),
		typerefinestack_(nil),
		incondition_(0),
		decltypevars_(nil)
	{
		labels_.next = labels_.prev = (Label*)&labels_;
		memset(&arena_, 0, sizeof arena_);
	}
	

	int reachable_;	// is the current code reachable?
	vector<Label*> breakstack_;
	vector<Label*> continuestack_;
	Frame *frame_;
	Scope *scope_;
	Fn *fn_;
	LabelStub labels_;
	Arena arena_;
	PatternCompileState *pcs_;
	List<TypeRefinement*> *typerefines_;
	List<List<TypeRefinement*>*> *typerefinestack_;
	int incondition_;
	List<Type*> *decltypevars_;
};

